﻿// Copyright (c) 2020, Identix identix@identix.com.br
// 
// Permission to use, copy, modify, and/or distribute this software for any purpose with or without fee is hereby granted, provided that the above copyright notice and this permission notice appear in all copies.
// 
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

using System;
using System.Collections.Generic;
using Microsoft.Win32;

namespace Identix.SerialSDK.Examples.GetComPort
{
    /// <summary>
    /// Example for detect com ports
    /// </summary>
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Press any key to continue...");
            Console.ReadLine();

            var comPorts = GetAvaiableComPorts();

            if (comPorts != null && comPorts.Count > 0)
            {
                foreach (var com in comPorts)
                {
                    Console.WriteLine("Avaiable: {0}", com);
                }
            }
            else
            {
                Console.WriteLine("No avaiable COM ports!");
            }

            Console.WriteLine("Press any key to continue...");
            Console.ReadLine();
        }

        private static List<string> GetAvaiableComPorts()
        {
            try
            {
                List<string> comPorts = new List<string>();

                var Rk1 = Registry.LocalMachine;
                var Rk2 = Rk1.OpenSubKey("HARDWARE\\DEVICEMAP\\SERIALCOMM");

                foreach (string S1 in Rk2.GetValueNames())
                {
                    if (S1.Contains("USBSER0")) comPorts.Add((string)Rk2.GetValue(S1));
                }

                return comPorts;
            }
            catch (Exception)
            {
                return null;
            }
        }
    }
}